<template>
    <div class="container mx-auto mt-4 px-6 lg:px-8">
        <!-- start form -->
        <form @submit.prevent="onLogin" class="space-y-4">
            <div class="form-control">
                <label class="flex flex-col" for="email">
                    <div class="font-semibold">
                        Email <span class="text-red-500">*</span>
                    </div>
                    <input
                        v-model="email"
                        id="email"
                        type="text"
                        class="focus:border-main-color rounded-lg border border-gray-200 mt-1 px-4 py-3"
                        :class="{ 'border-red-400': errEmail }"
                        placeholder="example@gmail.com"
                        autofocus
                    />
                </label>
                <div
                    v-if="errEmail"
                    class="text-left text-sm text-red-500 mt-1"
                >
                    {{ errEmail }}
                </div>
            </div>

            <div class="form-control">
                <label class="flex flex-col" for="password">
                    <div class="font-semibold">
                        Mật khẩu <span class="text-red-500">*</span>
                    </div>
                    <div class="relative">
                        <input
                            v-model="password"
                            id="password"
                            :type="isShowPassword ? 'text' : 'password'"
                            class="w-full rounded-lg border focus:border-main-color border-gray-200 mt-1 px-4 py-3"
                            :class="{ 'border-red-400': errPassword }"
                            placeholder="●●●●●●●●"
                        />
                        <div
                            @click="onToggleShowPassword"
                            class="absolute top-1/2 right-2 transform -translate-y-1/2 z-10 cursor-pointer text-gray-500"
                        >
                            <Tooltip :text="isShowPassword ? 'Ẩn' : 'Hiện'">
                                <EyeIcon v-if="isShowPassword" />
                                <EyeOffIcon v-else />
                            </Tooltip>
                        </div>
                    </div>
                </label>
                <div
                    v-if="errPassword"
                    class="text-left text-sm text-red-500 mt-1"
                >
                    {{ errPassword }}
                </div>

                <div class="mt-2">
                    <label
                        for="remember"
                        class="inline-flex items-center gap-1"
                    >
                        <input
                            v-model="rememberUser"
                            id="remember"
                            type="checkbox"
                            class="border"
                        />
                        <span class="text-sm">Nhớ tài khoản</span>
                    </label>
                </div>
            </div>

            <div class="form-control">
                <button
                    type="submit"
                    class="w-full py-3 text-center text-white font-bold rounded-lg hover:shadow-hover-primary"
                    :class="[
                        isLoading
                            ? 'bg-gray-800 cursor-not-allowed'
                            : 'bg-main-color'
                    ]"
                >
                    {{ isLoading ? "Đang đăng nhập..." : "Đăng nhập" }}
                </button>
            </div>
        </form>
        <!-- end form -->

        <!-- start errorResponse -->
        <div v-if="errorResponse" class="text-center text-red-500 mt-4">
            {{ errorResponse }}
        </div>
        <!-- end errorResponse -->
    </div>
</template>

<script>
import { inject, ref, watch } from "vue";
import { useRouter } from "vue-router";
import { ROLE_ADMIN, ROLE_TEACHER } from "@/constants";
import localStorageHelper from "@/helper/localStorageHelper";

import { useLogin } from "@/hooks/auth/useLogin";

import { EyeIcon, EyeOffIcon } from "@heroicons/vue/outline";
import Tooltip from "@/components/tooltip/Tooltip.vue";

export default {
    components: {
        EyeIcon,
        EyeOffIcon,
        Tooltip
    },
    setup() {
        const store = inject("store");
        const router = useRouter();
        const { errorResponse, isLoading, login } = useLogin();

        const email = ref("");
        const password = ref("");
        const rememberUser = ref(false);

        const errEmail = ref(null);
        const errPassword = ref(null);

        // get remember user
        const userStorage = localStorageHelper.getRememberUser();
        if (userStorage) {
            email.value = userStorage.email;
            password.value = userStorage.password;
            rememberUser.value = true;
        }

        // watch email
        watch(email, newValue => {
            if (!newValue) errEmail.value = "Bạn chưa nhập email";
            else errEmail.value = null;
        });

        // watch password
        watch(password, newValue => {
            if (!newValue) errPassword.value = "Bạn chưa nhập mật khẩu";
            else errPassword.value = null;
        });

        // login
        async function onLogin() {
            if (!email.value || !password.value) {
                if (!email.value) {
                    errEmail.value = "Bạn chưa nhập email";
                }
                if (!password.value) {
                    errPassword.value = "Bạn chưa nhập mật khẩu";
                }
            } else {
                await login(email.value, password.value, rememberUser.value);
                if (!errorResponse.value) {
                    store.methods.setUser();

                    let routeNameHomePageRole = "student";
                    if (store.state.user.role === ROLE_ADMIN) {
                        routeNameHomePageRole = "admin";
                    } else if (store.state.user.role === ROLE_TEACHER) {
                        routeNameHomePageRole = "teacher";
                    }

                    router.push({ name: routeNameHomePageRole, params: {} });
                }
            }
        }

        // show password
        const isShowPassword = ref(false);
        function onToggleShowPassword() {
            isShowPassword.value = !isShowPassword.value;
        }

        return {
            errorResponse,
            isLoading,
            onLogin,
            email,
            password,
            rememberUser,
            errEmail,
            errPassword,
            isShowPassword,
            onToggleShowPassword
        };
    }
};
</script>
